// Ionic Starter App
var db = null;
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
var peruhop = angular.module('peruhop', ['ionic', 'angular-bind-html-compile', 'ngCordova', 'peruhop.services'])

    .run(function ($ionicPlatform, $cordovaSQLite, Utils) {
        $ionicPlatform.ready(function () {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            //if (window.cordova && window.cordova.plugins.Keyboard) {
            //    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            //}
            if (window.StatusBar) {
                StatusBar.styleDefault();
            }
        });
    })

    .config(function ($stateProvider, $urlRouterProvider) {

        // Ionic uses AngularUI Router which uses the concept of states
        // Learn more here: https://github.com/angular-ui/ui-router
        // Set up the various states which the app can be in.
        // Each state's controller can be found in controllers.js
        $stateProvider

            .state('loader', {
                url: '/loader',
                templateUrl: 'loader.html',
                cache: false,
                resolve: {
                    dbReady: function ($q, $log, Utils, $ionicLoading) {
                        // (1) init the DB
                        var q = $q.defer();
                        //console.log("init");
                        $ionicLoading.show({
                            content: 'Loading',
                            animation: 'fade-in',
                            showBackdrop: true,
                            maxWidth: 200,
                            showDelay: 0
                        });
                        setTimeout(function () {
                            Utils.checkDb().then(function () {
                                $log.log("initDB promise resolved");
                                q.resolve();
                                $ionicLoading.hide();
                            });
                        }, 1000);
                        return q.promise;
                    }
                },
                controller: function ($scope, $cordovaNetwork, $ionicScrollDelegate, DB_CONFIG, DB, dbReady, Categories, $ionicLoading, $timeout, $location) {

                    console.log($cordovaNetwork);

                    $ionicLoading.hide();
                    $location.path('/');

                    $scope.remoteAssets = DB_CONFIG.remoteAssets;

                    $ionicLoading.show({
                        content: 'Loading',
                        animation: 'fade-in',
                        showBackdrop: true,
                        maxWidth: 200,
                        showDelay: 0
                    });

                }
            })

            .state('page1', {
                url: '/',
                templateUrl: 'page1.html',
                cache: false,
                controller: function ($scope, $cordovaNetwork, $ionicScrollDelegate, DB_CONFIG, DB, Categories, $ionicLoading, $ionicHistory) {

                    $ionicHistory.clearHistory();

                    console.log($cordovaNetwork);

                    $scope.remoteAssets = DB_CONFIG.remoteAssets;

                    $ionicLoading.hide();

                    Categories.all().then(function (categories) {
                        console.log(categories);
                        $scope.categories = categories;
                    });


                }
            })
            .state('page2', {
                url: '/page2/:id',
                templateUrl: 'page2.html',
                cache: false,
                controller: function ($scope, $location, $stateParams, $ionicScrollDelegate, DB_CONFIG, DB, Items, Categories) {
                    //console.log($scope);
                    $scope.remoteAssets = DB_CONFIG.remoteAssets;

                    Categories.getById($stateParams.id).then(function (documents) {
                        $scope.category = documents;
                        console.log(documents);
                    });

                    Items.allByCat($stateParams.id).then(function (documents) {
                        $scope.groups = documents;
                    });
                    $scope.myGoBack = function () {
                        $location.path('/');
                    };
                    $scope.GoWeb = function (link) {
                        window.open(link, '_system', 'location=yes');
                    };
                    $scope.toggleGroup = function (group) {
                        if ($scope.isGroupShown(group)) {
                            $scope.shownGroup = null;
                        } else {
                            $scope.shownGroup = group;
                        }
                        $ionicScrollDelegate.resize();
                    };
                    $scope.isGroupShown = function (group) {
                        return $scope.shownGroup === group;
                    };
                },
                onEnter: function () {
                    console.log('onEnter');
                    //$scope.shownGroup = null;
                }

            });

        // if none of the above states are matched, use this as the fallback

        $urlRouterProvider.otherwise('/loader');


    }).directive(
        "simpleAccordion",
        function ($parse) {
            function link($scope, element, attributes, $ionicScrollDelegate) {
                var children = element[0].childNodes;
                var num = 0;
                var pos = -1;
                var elmClick;
                var elmContent;
                for (var i = 0; i < children.length; i++) {
                    var elm = angular.element(children[i]);
                    if (elm.hasClass("title")) {
                        elmClick = elm;
                        elmClick.append('<i class="icon icon-arrow ion-chevron-down"></i>');
                    }
                    if (elm.hasClass("simple-accordion-content")) {
                        elmContent = elm;
                    }
                }
                elmClick.on('click', function (event) {
                    elmContent.toggleClass('active');
                    var icon = elmClick.find("i");
                    if (elmContent.hasClass('active')) {
                        icon.addClass('ion-chevron-up').removeClass('ion-chevron-down');
                    } else {
                        icon.addClass('ion-chevron-down').removeClass('ion-chevron-up');
                    }
                });
                //element.on('click', function (event) {
                //    var children = this.parentNode.childNodes;
                //    var num = 0;
                //    var pos = -1;
                //    for (var i = 0; i < children.length; i++) {
                //        if (children[i] == this) {
                //            pos = num;
                //            this.className = "on tab-item-custom"
                //        }
                //        if (children[i].nodeType == 1) {
                //            if (pos != num) {
                //                children[i].className = "tab-item-custom"
                //            }
                //            num++;
                //        }
                //    }
                //    num = 0;
                //    var childrenContent = this.parentNode.parentNode.childNodes;
                //    for (var i = 0; i < childrenContent.length; i++) {
                //        var elm = angular.element(childrenContent[i]);
                //        if (elm.hasClass("content-tab")) {
                //            if (pos == num) {
                //                elm.addClass("active");
                //            } else {
                //                elm.removeClass("active");
                //            }
                //            num++;
                //        }
                //    }
                //});
                //
                //angular.element(element.parent().find("a")[0]).triggerHandler('click');


                // -------------------------------------- //
                // -------------------------------------- //


                // When the scope is destroyed, clean up.
                //$scope.$on(
                //    "$destroy",
                //    function (event) {
                //
                //        element.off("click.bnDelegate");
                //
                //    }
                //);


            }

            // Return the directive configuration.
            return ({
                link: link,
                restrict: "C"
            });

        }
    ).directive(
        "tabItemCustom",
        function ($parse) {
            function link($scope, element, attributes, $ionicScrollDelegate) {
                element.on('click', function (event) {
                    var children = this.parentNode.childNodes;
                    var num = 0;
                    var pos = -1;
                    for (var i = 0; i < children.length; i++) {
                        if (children[i] == this) {
                            pos = num;
                            this.className = "on tab-item-custom"
                        }
                        if (children[i].nodeType == 1) {
                            if (pos != num) {
                                children[i].className = "tab-item-custom"
                            }
                            num++;
                        }
                    }
                    num = 0;
                    var childrenContent = this.parentNode.parentNode.childNodes;
                    for (var i = 0; i < childrenContent.length; i++) {
                        var elm = angular.element(childrenContent[i]);
                        if (elm.hasClass("content-tab")) {
                            if (pos == num) {
                                elm.addClass("active");
                            } else {
                                elm.removeClass("active");
                            }
                            num++;
                        }
                    }
                });

                angular.element(element.parent().find("a")[0]).triggerHandler('click');


                // -------------------------------------- //
                // -------------------------------------- //


                // When the scope is destroyed, clean up.
                //$scope.$on(
                //    "$destroy",
                //    function (event) {
                //
                //        element.off("click.bnDelegate");
                //
                //    }
                //);


            }

            // Return the directive configuration.
            return ({
                link: link,
                restrict: "C"
            });

        }
    );

